<script setup>
import { computed, ref, watch } from "vue";
import { useStore } from "vuex";

const store = useStore();
const notifications = ref([]);

const createNotification = ({
	text = "",
	timeout = 5000,
	type = "error", // success | error | warning
}) => {
	let newItem = {
		id: notifications.value.length,
		text,
		type,
	};
	notifications.value = [...notifications.value, newItem];
	setTimeout(() => {
		remove(newItem.id);
	}, timeout);
};
const remove = (id) => {
	notifications.value = notifications.value.filter((el) => el.id != id);
};

let list = computed(() => store.state.notification.list);

watch(list, (_val) => {
	console.log("_val: ", _val[_val.length - 1]);
	createNotification(_val[_val.length - 1]);
});
</script>

<template>
	<div class="wrapper">
		<TransitionGroup mode="in-out" name="notification" tag="div">
			<div
				class="notification flex-center"
				:class="item.type"
				v-for="item in notifications"
				:key="item.id"
			>
				<div class="medium">{{ item.text }}</div>
				<button class="btn" @click="remove(item.id)">Ok</button>
			</div>
		</TransitionGroup>
	</div>
</template>

<style lang="scss" scoped>
.wrapper {
	position: fixed;
	left: 50%;
	transform: translateX(-50%);
}

.notification {
	background: rgb(2, 103, 7);
	color: #fff;
	padding: 15px 30px;
	border-radius: 5px;
	display: flex;
	flex-direction: row;
	margin-top: 10px;

	&.error {
		background: rgb(181, 49, 16);
	}
	&.warning {
		background: rgb(196, 126, 7);
	}
	.btn {
		border-color: #fff;
		margin: 0px;
		margin-left: 50px;
		padding: 4px 15px;
		background: transparent;
	}
}

/* we will explain what these classes do next! */
.notification-enter-active,
.notification-leave-active {
	transition: all 0.7s;
}

.notification-enter-from,
.notification-leave-to {
	opacity: 0;
	transform: translateY(-20px);
}
</style>
